{$I SRCOMOPT.INC}
unit Srmain;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, WMacro,
  StdCtrls, SysUtils, Messages, Dialogs;

type
  TSuperRecorder = class(TForm)
    MacroSet1: TMacroSet;
    Keys: TListBox;
    Status: TLabel;
    Assign: TButton;
    FastPlay: TCheckBox;
    SysWide: TCheckBox;
    GroupBox1: TGroupBox;
    IgnoreMouse: TRadioButton;
    MouseClicks: TRadioButton;
    AllMouse: TRadioButton;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    MaxMacs: TEdit;
    MaxLen: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    MacroName: TEdit;
    Reinstall: TButton;
    SaveBtn: TButton;
    LoadBtn: TButton;
    Merge: TCheckBox;
    Label7: TLabel;
    RecordKeyMsg: TLabel;
    ScrapMacroKeyMsg: TLabel;
    CancelKeyMsg: TLabel;
    AssignCodeMacro: TButton;
    MacroKeyComboBox1: TMacroKeyComboBox;
    CancelCheck: TCheckBox;
    Label8: TLabel;
    Memo1: TMemo;
    PauseKeyMsg: TLabel;
    DeleteBtn: TButton;
    GroupBox3: TGroupBox;
    MousePointer: TRadioButton;
    MouseWindow: TRadioButton;
    MouseScreen: TRadioButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Toggles: TGroupBox;
    CapsLockButton: TButton;
    NumlockButton: TButton;
    ScrollLockButton: TButton;
    Edit2: TEdit;
    procedure FastPlayClick(Sender: TObject);
    procedure SysWideClick(Sender: TObject);
    procedure IgnoreMouseClick(Sender: TObject);
    procedure MouseClicksClick(Sender: TObject);
    procedure AllMouseClick(Sender: TObject);
    procedure AssignClick(Sender: TObject);
    procedure ReinstallClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MacroSet1Recorded(Sender: TObject; State: TUserMacroEngineState);
    procedure MacroSet1Played(Sender: TObject; State: TUserMacroEngineState);
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AssignCodeMacroClick(Sender: TObject);
    procedure CancelCheckClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure MousePointerClick(Sender: TObject);
    procedure MouseWindowClick(Sender: TObject);
    procedure MouseScreenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MacroSet1Assigned(Sender: TObject; Macro: Pointer);
    procedure Button2Click(Sender: TObject);
    procedure CapsLockButtonClick(Sender: TObject);
    procedure ScrollLockButtonClick(Sender: TObject);
    procedure NumlockButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SuperRecorder: TSuperRecorder;
  OurWindow : HWND;
  OldCursor,BIGPOINT : HCursor;

implementation
const
  OffOn : array[boolean] of string = ('OFF','ON ');
  SlowMouseVDelta = 5;
  SlowMouseHDelta = 5;
  FastMouseVDelta = 30;
  FastMouseHDelta = 30;

{$R *.DFM}
{$R BIGPOINT.RES}

procedure TSuperRecorder.FastPlayClick(Sender: TObject);
begin
  MacroSet1.FastPlayback:=FastPlay.Checked;
end;

procedure TSuperRecorder.SysWideClick(Sender: TObject);
begin
  MacroSet1.SystemWide:=SysWide.Checked;
end;

procedure TSuperRecorder.IgnoreMouseClick(Sender: TObject);
begin
  If IgnoreMouse.Checked then MacroSet1.RecordMouse:=RMIgnore;
end;

procedure TSuperRecorder.MouseClicksClick(Sender: TObject);
begin
  If MouseClicks.Checked then MacroSet1.RecordMouse:=RMClicksAndDrags;
end;

procedure TSuperRecorder.AllMouseClick(Sender: TObject);
begin
  If AllMouse.Checked then MacroSet1.RecordMouse:=RMAll;
end;

procedure TSuperRecorder.AssignClick(Sender: TObject);
begin
  try
    With MacroSet1, MacroKeyComboBox1 do
      If (MKey>0) then Add(MKey,ScrapMacro,MacroName.Text,nil);
  except
  on Exception Do MessageBox(0,'An error occurred while adding the key macro','',MB_APPLMODAL);
  end;
end;

procedure TSuperRecorder.ReinstallClick(Sender: TObject);
begin
  Keys.Items.Clear;
  With MacroSet1 do begin
    If MacrosOn then MacrosOff;
    MaxMacros:=StrToInt(MaxMacs.Text);
    MaxMacroLen:=StrToInt(MaxLen.Text);
    MacrosOn;
  end;
end;

function GetTopLevelWindow(Handle : HWND) : HWND;
begin
  while (GetParent(Handle)<>0) do Handle:=GetParent(Handle);
  result:=Handle;
end;

procedure ExampleCodeMacroProcedure; export;
begin
  MessageBox(0,'Example Code Macro Procedure','',MB_APPLMODAL);
end;

Procedure RunProg(const Prog : Pchar);
begin
  WinExec(Prog,SW_SHOWNORMAL);
end;

procedure RunCalc; export;
begin
  RunProg('CALC.EXE');
end;

procedure RunNotePad; export;
begin
  RunProg('NOTEPAD.EXE');
end;

procedure RunCalendar; export;
begin
  RunProg('CALENDAR.EXE');
end;

procedure RunClock; export;
begin
  RunProg('CLOCK.EXE');
end;

procedure MoveMouseUp; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.y:=MousePos.y-SlowMouseVDelta;
  If (MousePos.y<0) then MousePos.y:=0;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseLeft; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.x:=MousePos.x-SlowMouseHDelta;
  If (MousePos.x<0) then MousePos.x:=0;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseRight; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.x:=MousePos.x+SlowMouseHDelta;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseDown; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.y:=MousePos.y+SlowMouseVDelta;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseUpFast; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.y:=MousePos.y-FastMouseVDelta;
  If (MousePos.y<0) then MousePos.y:=0;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseLeftFast; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.x:=MousePos.x-FastMouseHDelta;
  If (MousePos.x<0) then MousePos.x:=0;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseRightFast; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.x:=MousePos.x+FastMouseHDelta;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseDownFast; export;
var
  MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  MousePos.y:=MousePos.y+FastMouseVDelta;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseUpperLeft; export;
var
  MousePos : TPoint;
begin
  With MousePos do begin
    x:=0;
    y:=0;
  end;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseUpperRight; export;
var
  MousePos : TPoint;
begin
  With MousePos do begin
    x:=2048;
    y:=0;
  end;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseLowerLeft; export;
var
  MousePos : TPoint;
  ScreenHeight : Integer;
begin
  ScreenHeight := GetSystemMetrics(SM_CYSCREEN);
  With MousePos do begin
    x:=0;
    y:=ScreenHeight;
  end;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseLowerRight; export;
var
  MousePos : TPoint;
  ScreenWidth, ScreenHeight : Integer;
begin
  ScreenWidth := GetSystemMetrics(SM_CXSCREEN);
  ScreenHeight := GetSystemMetrics(SM_CYSCREEN);
  With MousePos do begin
    x:=ScreenWidth;
    y:=ScreenHeight;
  end;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MoveMouseCenter; export;
var
  MousePos : TPoint;
  ScreenWidth, ScreenHeight : Integer;
begin
  ScreenWidth := GetSystemMetrics(SM_CXSCREEN);
  ScreenHeight := GetSystemMetrics(SM_CYSCREEN);
  With MousePos do begin
    x:=ScreenWidth div 2;
    y:=ScreenHeight div 2;
  end;
  SetCursorPos(MousePos.x,MousePos.y);
end;

procedure MagnifyPointer; export;
var
  CurCursor : HCursor;
begin
  CurCursor:=GetCursor;
  If (CurCursor<>BIGPOINT) then begin
    OldCursor:=CurCursor;
    SetCursor(BIGPOINT);
  end;
end;

procedure ShrinkPointer; export;
var
  CurCursor : HCursor;
begin
  CurCursor:=GetCursor;
  If (CurCursor=BIGPOINT) then
    SetCursor(OldCursor);
end;

procedure TypeIt; export;
begin
  SuperRecorder.MacroSet1.SendText('Written by Ken Henderson');
end;

procedure SendKeysProc; export;
const
  temp : pchar = '{ESC}4{+}5~'#0;
begin
  SuperRecorder.MacroSet1.SendKeys(temp);
end;

procedure ClickLeftButton; export;
var
  MousePos : TPoint;
  Lparam : Longint;
  CurWin : HWND;
  CurRect : TRect;
begin
  GetCursorPos(MousePos);
  CurWin := WindowFromPoint(MousePos);
  GetWindowRect(CurWin, CurRect);
  Lparam:=MakeLong(MousePos.X-CurRect.Left, MousePos.Y-CurRect.Top);
  SendMessage(CurWin,WM_LBUTTONDOWN,0,Lparam);
  SendMessage(CurWin,WM_LBUTTONUP,0,Lparam);
end;

procedure DoubleClickLeftButton; export;
var
  MousePos : TPoint;
  Lparam : Longint;
  CurWin : HWND;
  CurRect : TRect;
begin
  ClickLeftButton;
  GetCursorPos(MousePos);
  CurWin := WindowFromPoint(MousePos);
  GetWindowRect(CurWin, CurRect);
  Lparam:=MakeLong(MousePos.X-CurRect.Left, MousePos.Y-CurRect.Top);
  SendMessage(CurWin,WM_LBUTTONDBLCLK,0,Lparam);
end;

procedure TSuperRecorder.FormCreate(Sender: TObject);
begin
  BIGPOINT:=LoadCursor(hInstance,pchar(255));
  With MacroSet1 do begin
    FastPlay.Checked:=FastPlayback;
    SysWide.Checked:=SystemWide;
    IgnoreMouse.Checked:=(RecordMouse=RMIgnore);
    MouseClicks.Checked:=(RecordMouse=RMClicksAndDrags);
    MousePointer.Checked:=(MouseBase=MBPointer);
    MouseWindow.Checked:=(MouseBase=MBWindow);
    MouseScreen.Checked:=(MouseBase=MBScreen);
    AllMouse.Checked:=(RecordMouse=RMAll);
    MaxMacs.Text:=IntToStr(MaxMacros);
    MaxLen.Text:=IntToStr(MaxMacroLen);
    CancelCheck.Checked:=CancelChecking;
    CancelKey:=VK_CANCEL;
    MacrosOn;
    RecordKeyMsg.Caption:=RecordKeyMsg.Caption+KeyNames[ToggleRecordKey];
    ScrapMacroKeyMsg.Caption:=ScrapMacroKeyMsg.Caption+KeyNames[Keys[-1]];
    CancelKeyMsg.Caption:=CancelKeyMsg.Caption+KeyNames[CancelKey];
    PauseKeyMsg.Caption:=PauseKeyMsg.Caption+KeyNames[PauseKey];
    Caption:='SuperRecorder Macro Recorder.  DLL Version: '+Version+'. Written by Ken Henderson.';
    If (ParamCount=0) then begin
    {Install some demo code macros}
    Add(MK_CTRLALTC,ScrapMacro,'Run CALC.EXE',RunCalc);
    Add(MK_CTRLALTN,ScrapMacro,'Run NOTEPAD.EXE',RunNotePad);
    Add(MK_CTRLSHIFTRBTN,ScrapMacro,'Run CALENDAR.EXE',RunCalendar);
    Add(MK_CTRLNUMSLASH,ScrapMacro,'Run CLOCK.EXE',RunClock);
    Add(MK_CTRLS,ScrapMacro,'Send keys "{ESC}4{+}5~"',SendKeysProc);
    Add(MK_MBTN,ScrapMacro,'Left mouse double click', DoubleClickLeftButton);
    {$IFDEF BLINDGUY}
    Add(MK_SHIFTUP,ScrapMacro,'Move mouse up',MoveMouseUp);
    Add(MK_SHIFTDOWN,ScrapMacro,'Move mouse down',MoveMouseDown);
    Add(MK_SHIFTLEFT,ScrapMacro,'Move mouse left',MoveMouseLeft);
    Add(MK_SHIFTRIGHT,ScrapMacro,'Move mouse right',MoveMouseRight);
    Add(MK_SHIFTNUM8,ScrapMacro,'Move mouse up',MoveMouseUp);
    Add(MK_SHIFTNUM2,ScrapMacro,'Move mouse down',MoveMouseDown);
    Add(MK_SHIFTNUM4,ScrapMacro,'Move mouse left',MoveMouseLeft);
    Add(MK_SHIFTNUM6,ScrapMacro,'Move mouse right',MoveMouseRight);
    Add(MK_SHIFTHOME,ScrapMacro,'Move mouse to upper left',MoveMouseUpperLeft);
    Add(MK_SHIFTPGUP,ScrapMacro,'Move mouse to upper right',MoveMouseUpperRight);
    Add(MK_SHIFTEND,ScrapMacro,'Move mouse to lower left',MoveMouseLowerLeft);
    Add(MK_SHIFTPGDN,ScrapMacro,'Move mouse to lower right',MoveMouseLowerRight);
    Add(MK_CTRLSHIFTCENTER,ScrapMacro,'Move mouse to screen center',MoveMouseCenter);
    Add(MK_ALTSHIFTENTER,ScrapMacro,'Left mouse click',ClickLeftButton);
    Add(MK_CTRLALTENTER,ScrapMacro,'Left mouse double click', DoubleClickLeftButton);
    Add(MK_CTRLSHIFTM,ScrapMacro,'Magnify pointer',MagnifyPointer);
    Add(MK_CTRLSHIFTS,ScrapMacro,'Shrink pointer',ShrinkPointer);
    {$ENDIF}
    Add(MK_BACKQUOTE,ScrapMacro,'Type text',TypeIt);
    end else begin
       OpenDialog1.FileName:=UpperCase(ParamStr(1));
       ReadFromFile(OpenDialog1.FileName,true);
    end;
    CapsLockButton.Caption:='Caps '+OffOn[CapsLock];
    NumLockButton.Caption:='Num '+OffOn[NumLock];
    ScrollLockButton.Caption:='Scroll '+OffOn[ScrollLock];
  end;
end;

procedure TSuperRecorder.MacroSet1Recorded(Sender: TObject; State: TUserMacroEngineState);
begin
  Status.Caption:=MacroSet1.StateName[State];
end;

procedure TSuperRecorder.MacroSet1Played(Sender: TObject; State: TUserMacroEngineState);
begin
  Status.Caption:=MacroSet1.StateName[State];
end;

procedure TSuperRecorder.SaveBtnClick(Sender: TObject);
begin
  If (SaveDialog1.FileName='') and (OpenDialog1.FileName<>'') then
    SaveDialog1.FileName:=OpenDialog1.FileName;
  If (SaveDialog1.Execute) then MacroSet1.SaveToFile(SaveDialog1.FileName);
end;

procedure TSuperRecorder.LoadBtnClick(Sender: TObject);
begin
  If (OpenDialog1.Execute) then MacroSet1.ReadFromFile(OpenDialog1.FileName,Merge.Checked);
end;

procedure TSuperRecorder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MacroSet1.MacrosOff;
  DestroyCursor(BIGPOINT);
end;

procedure TSuperRecorder.AssignCodeMacroClick(Sender: TObject);
Var
  MKey : Word;
begin
  try
    OurWindow:=SuperRecorder.Handle;
    With MacroSet1, MacroKeyComboBox1 do
      If (MKey>0) then Add(MKey,ScrapMacro,MacroName.Text,ExampleCodeMacroProcedure);

  except
  on Exception Do MessageBox(0,'An error occurred while adding the Code Macro','',MB_APPLMODAL);
  end;
end;

procedure TSuperRecorder.CancelCheckClick(Sender: TObject);
begin
  MacroSet1.CancelChecking:=CancelCheck.Checked;
end;

procedure TSuperRecorder.DeleteBtnClick(Sender: TObject);
begin
  if ((keys.itemindex <> -1) and (MessageDlg('Delete macro?',mtConfirmation,mbYesNoCancel,0)=mrYes)) then
    macroset1.delete(macroset1.keys[succ(keys.itemindex)]);
end;

procedure TSuperRecorder.MousePointerClick(Sender: TObject);
begin
  If MousePointer.Checked then MacroSet1.MouseBase:=MBPointer;
end;

procedure TSuperRecorder.MouseWindowClick(Sender: TObject);
begin
  If MouseWindow.Checked then MacroSet1.MouseBase:=MBWindow;
end;

procedure TSuperRecorder.MouseScreenClick(Sender: TObject);
begin
  If MouseScreen.Checked then MacroSet1.MouseBase:=MBScreen;
end;

procedure TSuperRecorder.Button1Click(Sender: TObject);
var
  temp : string;
begin
  ActiveControl:=Memo1;
  temp:=edit1.text+#0;
  macroset1.SendKeys(@temp[1]);
end;

procedure TSuperRecorder.MacroSet1Assigned(Sender: TObject;
  Macro: Pointer);
var
  MMacs : word;
  MCnt : byte;
begin
  Keys.Items.Clear;
  MMacs:=MacroSet1.MaxMacros;
  For MCnt:=0 to pred(MMacs) do begin
    try
      Keys.Items.Add(MacroSet1.KeyNames[MacroSet1.Keys[MCnt]]+' -> '+MacroSet1.Names[MacroSet1.Keys[MCnt]]);
    except
      on EMacroNotFound Do {We don't care about not finding our macros};
    end;
  end;
end;

procedure TSuperRecorder.Button2Click(Sender: TObject);
begin
  MacroSet1.AppActivate(Edit2.Text);
end;

procedure TSuperRecorder.CapsLockButtonClick(Sender: TObject);
begin
  With MacroSet1 do begin
    If CapsLock then CapsLock:=false
    else CapsLock:=true;
    CapsLockButton.Caption:='Caps '+OffOn[CapsLock];
  end;
end;

procedure TSuperRecorder.ScrollLockButtonClick(Sender: TObject);
begin
  With MacroSet1 do begin
    If ScrollLock then ScrollLock:=false
    else ScrollLock:=true;
    ScrollLockButton.Caption:='Scroll '+OffOn[ScrollLock];
  end;
end;

procedure TSuperRecorder.NumlockButtonClick(Sender: TObject);
begin
  With MacroSet1 do begin
    If NumLock then NumLock:=false
    else NumLock:=true;
    NumLockButton.Caption:='Num '+OffOn[NumLock];
  end;
end;

procedure TSuperRecorder.FormActivate(Sender: TObject);
begin
  With MacroSet1 do begin
    CapsLockButton.Caption:='Caps '+OffOn[CapsLock];
    NumLockButton.Caption:='Num '+OffOn[NumLock];
    ScrollLockButton.Caption:='Scroll '+OffOn[ScrollLock];
  end;
end;

initialization
end.
